package com.bbc.denadrive.apihandlers

import androidx.lifecycle.ViewModel
import kotlinx.serialization.SerializationException
import kotlinx.serialization.json.Json
import okhttp3.Response

class ResponsesHandler: ViewModel() {

    var lastResponse: String = ""
    var isComplete: Boolean = true
    private lateinit var respBuilder: StringBuilder
    private lateinit var lastResponseBody: DriveResponseBody

    fun newResponseArrived(response: Response) {
        if (isComplete) {
            respBuilder = StringBuilder("$response")
        }
        else {
            respBuilder.append("$response")
            updateCompleteness()
        }
    }

    private fun checkForCompleteness(): Pair<Boolean, DriveResponseBody?> {
        return try {
            Pair(true, Json.decodeFromString<DriveResponseBody>(respBuilder.toString()))
        } catch (e: SerializationException) {
            Pair(false, null)
        }
    }

    private fun updateCompleteness() {
        val pair = checkForCompleteness()
        isComplete = pair.first
        if (isComplete) {
            lastResponse = respBuilder.toString()
            lastResponseBody = pair.second!!
        }
    }

}