package com.bbc.denadrive.oauth

import android.content.Context
import androidx.security.crypto.EncryptedSharedPreferences
import androidx.security.crypto.MasterKey
import net.openid.appauth.AuthState

object AuthStatePersistence {

    fun retrieveAuthState(context: Context): AuthState {
        val masterKey = MasterKey.Builder(context)
            .setKeyScheme(MasterKey.KeyScheme.AES256_GCM)
            .build()

        val preferences = EncryptedSharedPreferences.create(
            context,
            "authState",
            masterKey,
            EncryptedSharedPreferences.PrefKeyEncryptionScheme.AES256_SIV,
            EncryptedSharedPreferences.PrefValueEncryptionScheme.AES256_GCM
        )

        preferences.getString("authState", null)?.let {
            return AuthState.jsonDeserialize(it)
        }
        return AuthState(retrieveAuthServConf())
    }

}